import axios from 'axios';
import React, { useState, useEffect } from 'react';
import { Form, Button, Row, Image, Col, Container } from 'react-bootstrap';
import { isAuthenticated } from '../utils/auth';
import catchErrors from '../utils/catchErrors';


function Chat(props) {
  const [user, setUser] = useState('')
  const [error, setError] = useState('')
  const [disabled, setDisabled] = useState(true)

  const userId = isAuthenticated()
  async function getProfile(userId) {
    try {
      const response = await axios.get(`/users/${userId}`)
      setUser(response.data)
    } catch (error) {
      catchErrors(error, setError)
    }
  }




  // let defaultname=''
  let defaultname = sessionStorage.getItem('name');

  const [inner, setInner] = useState([''])
  const [chat, setChat] = useState([inner])   //object로 key는 보낸사람 value는 메세지

  function handleChange(e) {
    e.preventDefault()
    setInner(e.target.value)
    console.log(e.target.value)
    setDisabled(false)
  }

  function sendMsgCH(e) {
    e.preventDefault()
    props.setSingleChat(inner)
    props.sendMsg(e)
    setInner('')
    setDisabled(true)
    console.log(chat)
  }
  useEffect(() => {
    getProfile(userId)
  }, [userId])

  useEffect(() => {
    setChat([...chat, props.singleChat])
    console.log('UseEffect singlechat', chat)
    // check()
  }, [props.singleChat])

  useEffect(() => {
    setChat([...chat, props.recievedMsg])
    console.log('UseEffect recievechat', chat)
  }, [props.recievedMsg])

  const time = new Date().toLocaleTimeString()
  return (

    <div className="chat" id="chat" style={{ border: "2px solid", height: "300%", margin: "1%", borderColor: "#BDBDBD", background: '' }}>
      <h2>현재 {props.roomName} 입니다.{chat.length}</h2>
      {/* 상대방이 보낸 메세지 띄우기 + 같은유저면 프로필 이미지는 생략(chat을 object로 보낸사람과 함께 보내서 구분하자) */}
      {      chat.map((value, index) => (
        <Row key={index} className='m-1 ml-3' >
          <Col xs={2}>
            {user.profileimg ? <Image src={user.profileimg && `/images/${user.profileimg}`} style={{ width: "50px", height: "50px" }} roundedCircle /> : <Image src='https://www.flaticon.com/svg/vstatic/svg/149/149071.svg?token=exp=1610922596~hmac=f4b972b9db509d4e3cc2eb40543b0b0f' style={{ width: "50px", height: "50px" }} roundedCircle />}
          </Col>
          <Col xs={8} className='justify-content-flex-start'>
            <Row>{user.nickname}</Row>
            <Row className='d-flex flex-wrap-nowrap'>
              <Row className='border border-dark' style={{ width: 'max-content', maxWidth: '300px', height: 'auto', paddingLeft: '15px', paddingRight: '15px', background: 'white', borderRadius: '5px', fontSize: 'x-large' }}>{value}</Row>
              <Col xs={5} className='ml-1'>{new Date().toLocaleTimeString()}</Col>
            </Row>
          </Col>
        </Row>
      ))
      }
      {/* 내가 보낸 메세지 띄우기 */}
      {      chat.map((value, index) => (
        <Row key={index} className='m-1 mr-5 justify-content-end'>
          <Row className='d-flex flex-wrap-nowrap' >
            <Col className='mr-1'>{time}</Col>
            <Row style={{ width: 'max-content', maxWidth: '300px', height: 'auto', paddingLeft: '15px', paddingRight: '15px', background: 'yellow', borderRadius: '3px', fontSize: 'x-large' }}>{value}</Row>
          </Row>
        </Row>

      ))
      }



      <Button variant="light" onClick={props.handleChatc} >{`<`}</Button>
      <Form onSubmit={sendMsgCH}>
        <Form.Group className='d-flex flex-wrap-nowrap justify-content-center ml-2 mr-2'>
          <Form.Control className='border border-warning' name='chat' type="text" value={inner} onChange={handleChange} style={{ width: '85%' }} />
          <Button variant="warning" type="submit" disabled={disabled} style={{ width: '10%' }}>
            전송
          </Button>
        </Form.Group>

      </Form>
    </div >


  );
}

export default Chat;
